"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Created by nadav on 12/03/2017.
 */
var UserMessageHelper = /** @class */ (function () {
    function UserMessageHelper(perfix, verbose) {
        this.perfix = perfix;
        this.verbose = verbose;
    }
    UserMessageHelper.prototype.println = function (text) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var message = this.perfix + " - " + text;
        if (args && args.length > 0) {
            for (var i = 0; i < args.length; i++) {
                var arg = args[i];
                if (arg instanceof Error) {
                    message += arg.message + "\n" + arg.stack;
                }
                else if (typeof arg === "object") {
                    message += JSON.stringify(arg);
                }
                else {
                    message = message + arg.toString();
                }
            }
        }
        console.log(message);
    };
    UserMessageHelper.prototype.printWarn = function (text) {
        this.println("WARNING - " + text);
    };
    UserMessageHelper.prototype.printError = function (text, error) {
        this.println("ERROR - " + text, error);
    };
    UserMessageHelper.prototype.printDebug = function (text) {
        if (this.verbose) {
            this.println("DEBUG - " + text);
        }
    };
    return UserMessageHelper;
}());
exports.UserMessageHelper = UserMessageHelper;
//# sourceMappingURL=UserMessageHelper.js.map