"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var state_tracker_process_1 = require("./state-tracker-process");
var uuid_1 = require("./uuid");
var wait_for_multiple_callbacks_1 = require("./wait-for-multiple-callbacks");
var sl_js_infra_1 = require("sl-js-infra");
var getSystemDate = sl_js_infra_1.SlJsInfra.getSystemDateValueOf;
var readline_1 = require("readline");
var EventTypes = sl_js_infra_1.SlJsInfra.Entities.EventTypes;
var version = require("../../package.json").version;
var NodeJsAgent = /** @class */ (function () {
    function NodeJsAgent(cfg, footprintsProcess, eventsProcess, logsProcess, stateTracker, configProcess, flushCurrentTestFootprints, coloringProviders, _testRecommendationHandler, _agentEventsController, logger) {
        var _this = this;
        this.cfg = cfg;
        this.footprintsProcess = footprintsProcess;
        this.eventsProcess = eventsProcess;
        this.logsProcess = logsProcess;
        this.stateTracker = stateTracker;
        this.configProcess = configProcess;
        this.flushCurrentTestFootprints = flushCurrentTestFootprints;
        this.coloringProviders = coloringProviders;
        this._testRecommendationHandler = _testRecommendationHandler;
        this._agentEventsController = _agentEventsController;
        this.logger = logger;
        this.isRunning = false;
        this.isStopping = false;
        if (!cfg)
            throw new Error("cfg is required");
        if (!footprintsProcess)
            throw new Error("footprintsProcess is required");
        if (!eventsProcess)
            throw new Error("eventsProcess is required");
        if (!logsProcess)
            throw new Error("logsProcess is required");
        if (!stateTracker)
            throw new Error("stateTracker is required");
        if (!configProcess)
            throw new Error("configProcess is required");
        if (!flushCurrentTestFootprints)
            throw new Error("flushCurrentTestFootprints is required");
        if (!coloringProviders)
            throw new Error("coloringProviders is required");
        if (!_testRecommendationHandler)
            throw new Error("testRecommendationHandler is required");
        if (!_agentEventsController)
            throw new Error("agentEventsController is required");
        if (!logger)
            throw new Error("logger is required");
        stateTracker.on("test_identifier_changed", function (newTestIdentifier, previousTestIdentifier) {
            if (previousTestIdentifier != null) {
                if (!_this.stateTracker.hasAnonymousMappingAtServer() && stateTracker.isAnonymousColor(previousTestIdentifier)) {
                    _this.logger.info("Test identifier changed, couldn't find active execution for anonymous footprints. Skip enqueuing footprints process.");
                    return;
                }
                _this.logger.debug("Test identifier changed, start enqueuing footprints process.");
                var prevTestIdentifierParts = state_tracker_process_1.StateTrackerProcess.splitTestIdToExecutionAndTestName(previousTestIdentifier);
                footprintsProcess.enqueueCurrentFootprints(prevTestIdentifierParts.executionId, prevTestIdentifierParts.testName);
            }
            else {
                _this.logger.info("Test identifier changed, previous identifier wasn't set, meaning that we didn't have active test. Skip enqueuing footprints process.");
            }
        });
        configProcess.on("configuration_changed", function (updatedCfg) {
            if (updatedCfg.enabled.value === false) {
                _this.stop(function () { });
            }
        });
        flushCurrentTestFootprints.on("alarm", function () {
            var currentTestIdentifier = stateTracker.getCurrentTestIdentifier();
            if (sl_js_infra_1.SlJsInfra.SlEnvVars.inProductionListenerMode()) {
                _this.logger.debug("Enqueue footprints for production listener");
                _this.enqueueFootprints(currentTestIdentifier);
                return;
            }
            if (currentTestIdentifier != null) {
                if (!_this.stateTracker.hasAnonymousMappingAtServer() && stateTracker.isAnonymousColor(currentTestIdentifier)) {
                    _this.logger.info("Enqueue footprints interval - couldn't find active execution for anonymous footprints. skip enqueue footprints process. currentTestIdentifier: '%s'", currentTestIdentifier);
                    return;
                }
                _this.logger.debug("Enqueue footprints interval - start enqueuing process. currentTestIdentifier: '%s'", currentTestIdentifier);
                _this.enqueueFootprints(currentTestIdentifier);
            }
            else {
                _this.logger.info("Enqueue footprints interval - no test identifier. skip enqueuing process. ");
            }
        });
    }
    NodeJsAgent.prototype.enqueueFootprints = function (currentTestIdentifier) {
        var testIdentifierParts = state_tracker_process_1.StateTrackerProcess.splitTestIdToExecutionAndTestName(currentTestIdentifier);
        this.footprintsProcess.enqueueCurrentFootprints(testIdentifierParts.executionId, testIdentifierParts.testName);
    };
    NodeJsAgent.prototype.getLogger = function (component) {
        return this.logger.child({ component: component });
    };
    Object.defineProperty(NodeJsAgent.prototype, "testRecommendationHandler", {
        get: function () {
            return this._testRecommendationHandler;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NodeJsAgent.prototype, "agentEventsController", {
        get: function () {
            return this._agentEventsController;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Starts the Test Listener
     *
     * @param {(err: Error) => void} [callback] Optional callback that will be called if agent is either disabled, or finished loading (incl. remote config)
     * @returns
     *
     * @memberOf NodeJsAgent
     */
    NodeJsAgent.prototype.start = function (callback) {
        var _this = this;
        this.logger.info("Agent is starting. process.argv: '" + process.argv.join(" ") + "'");
        if (this.cfg.enabled.value === false) {
            this.logger.warn("Agent is disabled");
            if (callback) {
                return callback(null);
            }
            return;
        }
        if (!this.cfg.token.hasValue) {
            this.logger.warn("Agent is disabled since token was not specified");
            if (callback) {
                return callback(null);
            }
            return;
        }
        if (this.isRunning) {
            this.logger.warn("Agent is already running");
            if (callback) {
                return callback(null);
            }
            return;
        }
        this._agentEventsController.submitAgentStartedEvent();
        this.flushCurrentTestFootprints.start();
        this.footprintsProcess.start();
        this.eventsProcess.start();
        this.logsProcess.start();
        this.stateTracker.start();
        this.configProcess.start(function (err) {
            if (callback) {
                return callback(null);
            } //Even if configuration failed to be loaded from the server, don't shut down the agent
        });
        this.coloringProviders.forEach(function (provider) {
            provider.setup(_this.cfg, _this.stateTracker, _this.logger);
        });
        this.registerGlobalAPI();
        this.registerShutdownEvents();
        this.isRunning = true;
        this.eventsProcess.enqueueEvent({
            type: EventTypes.AgentStarted,
            localTime: getSystemDate()
        });
        this.logger.info("Agent is now running");
    };
    NodeJsAgent.prototype.stop = function (callback) {
        return __awaiter(this, void 0, void 0, function () {
            var waiter;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.isRunning) {
                            return [2 /*return*/, callback()];
                        }
                        if (this.isStopping) {
                            this.logger.error("Already stopping", new Error());
                        }
                        this.isStopping = true;
                        this.logger.info("Agent is now stopping");
                        this.stateTracker.setTestIdentifier(null);
                        waiter = new wait_for_multiple_callbacks_1.WaitForMultipleCallbacks();
                        return [4 /*yield*/, this._agentEventsController.submitAgentShutdownEvent()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.eventsProcess.stop()];
                    case 2:
                        _a.sent();
                        this.flushCurrentTestFootprints.stop();
                        this.stateTracker.stop(waiter.getCallbackForProcess("stateTracker"));
                        this.footprintsProcess.stop(waiter.getCallbackForProcess("footprionts"));
                        this.logsProcess.stop(waiter.getCallbackForProcess("logs"));
                        this.logger.info("Agent is now stopped");
                        return [2 /*return*/, waiter.waitForAll(callback)];
                }
            });
        });
    };
    //PUBLIC INTERFACE
    NodeJsAgent.prototype.createExecutionId = function () {
        var now = getSystemDate().toString();
        var result = uuid_1.UUID.newGuid([now, this.cfg.customerId.value].join());
        return result;
    };
    //Deprecated
    NodeJsAgent.prototype.createTestSuiteId = function () {
        return this.createExecutionId();
    };
    NodeJsAgent.prototype.createTestId = function (executionId, testName) {
        return state_tracker_process_1.StateTrackerProcess.combineExecutionIdAndTestName(executionId, testName);
    };
    NodeJsAgent.prototype.setCurrentTestIdentifier = function (testIdentifier) {
        this.logger.info("Agent.setCurrentTestIdentifier - testIdentifier:'" + testIdentifier + "'.");
        this.stateTracker.setTestIdentifier(testIdentifier, false);
    };
    NodeJsAgent.getVersion = function () {
        return version;
    };
    NodeJsAgent.prototype.pushEvent = function (evt) {
        this.eventsProcess.enqueueEvent(evt);
    };
    NodeJsAgent.prototype.registerGlobalAPI = function () {
        var _this = this;
        var globalObject = global;
        var sealights = "$$SeaLights$$";
        if (globalObject[sealights])
            return;
        globalObject[sealights] = {
            setCurrentTestIdentifier: function (testIdentifier, silent) {
                _this.stateTracker.setTestIdentifier(testIdentifier, silent);
            },
            getCurrentTestIdentifier: function () {
                return _this.stateTracker.getCurrentTestIdentifier();
            },
            pushEvent: function (event) {
                _this.pushEvent(event);
            },
            shutdown: function (callback) {
                if (!callback)
                    throw new Error("'callback' is required.");
                _this.stop(callback);
            }
        };
    };
    ;
    NodeJsAgent.prototype.registerShutdownEvents = function () {
        var _this = this;
        var dummyCallback = function () {
        };
        process.on('SIGTERM', function () { return _this.stop(dummyCallback); });
        process.on('SIGINT', function () { return _this.stop(dummyCallback); });
    };
    // Enable if your'e running on windows and want to test shutdown process
    NodeJsAgent.prototype.registerShutdownEventsOnWindows = function () {
        var _this = this;
        var readLine = readline_1.createInterface({
            input: process.stdin,
            output: process.stdout
        });
        var windowsListener = function () {
            console.log("before exit");
            _this.stop(function () {
                process.exit();
            });
        };
        readLine.on("SIGINT", function () { windowsListener(); });
        readLine.on("SIGTERM", function () { windowsListener(); });
    };
    return NodeJsAgent;
}());
exports.NodeJsAgent = NodeJsAgent;
//# sourceMappingURL=agent.js.map