"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var program = require("commander");
var config_loader_1 = require("./config-process/config-loader");
var command_line_arg_parser_1 = require("./command-line-arg-parser");
var agent_loader_1 = require("./agent-loader");
var Module = require('module');
var nycBinFile = require.resolve('nyc/bin/nyc.js');
var version = require("../../package.json").version;
var patchChildProcess = require("./child-process-patcher.js").patchChildProcess;
//TODO: Agent formal CLIs
var NodeAgentCLI = /** @class */ (function () {
    function NodeAgentCLI() {
    }
    NodeAgentCLI.booleanOption = function (option) {
        return (option && option.toLowerCase() == "true");
    };
    NodeAgentCLI.execRun = function (argv, firstArgIdx) {
        var knownRunOptions = {
            "--cfg": { name: "cfg" },
            "--token": { name: "token" },
            "--tokenfile": { name: "tokenFile" },
            "--appname": { name: "appName" },
            "--branch": { name: "branch" },
            "--build": { name: "build" },
            "--usebranchcoverage": { name: "useBranchCoverage" },
            "--startagent": { name: "startAgent", type: "boolean" }
        };
        var parsedCmd = new command_line_arg_parser_1.CommandLineArgParser().parseCommand(argv, firstArgIdx, knownRunOptions);
        var configLoader = new config_loader_1.ConfigLoader();
        var agentCfg = configLoader.loadAgentConfiguration(parsedCmd.keysAndValues, parsedCmd.keysAndValues["cfg"]);
        var spawnNodeArgs = this.getSpawnNodeArgs();
        agent_loader_1.AgentLoader.init(agentCfg, parsedCmd.restArgs, spawnNodeArgs);
    };
    NodeAgentCLI.run = function () {
        var args = process.argv;
        var cmd = args[2];
        if (cmd == 'run')
            return NodeAgentCLI.execRun(process.argv, 3);
        program
            .command('*', "", { noHelp: true })
            .action(function (cmd) {
            program.help();
        });
        program.parse(process.argv);
    };
    NodeAgentCLI.runUserCode = function (args) {
        var bootstrapFile = require.resolve('./bootstrap');
        process.argv = [process.argv0, nycBinFile, "-i", bootstrapFile].concat(args);
        Module.runMain();
    };
    NodeAgentCLI.getSpawnNodeArgs = function () {
        var args = [];
        process.execArgv.forEach(function (arg) {
            if (arg.indexOf("--max_old_space_size") == 0) {
                args.push(arg);
            }
        });
        return args;
    };
    return NodeAgentCLI;
}());
exports.NodeAgentCLI = NodeAgentCLI;
NodeAgentCLI.run();
//# sourceMappingURL=cli.js.map