"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var http = require("http");
/**
 * Created by nadav on 19/03/2017.
 */
/**
 * This class creates an HTTP server that can be used in order to color the agent.
 * We'll probably need that when the client's uses something that is unsupported (ie, not HTTP).
 * The actual color will be set by the HttpColoring class.
 * */
var ListeningPort = /** @class */ (function () {
    function ListeningPort() {
    }
    ListeningPort.prototype.setup = function (config, stateTracker, log) {
        this.setupListeningPort(config, log);
    };
    ListeningPort.prototype.teardown = function () {
        this.stopListening();
    };
    ListeningPort.prototype.setupListeningPort = function (config, log) {
        var httpListeningPort = config.httpListeningPort.value;
        if (httpListeningPort) {
            //Create a server
            this.server = http.createServer(this.handleRequest);
            //Lets start our server
            this.server.listen(httpListeningPort, function () {
                log.info("[HTTP LISTENER] Agent is listening on port " + httpListeningPort + "]");
                try {
                    this.server.unref(); //Don't hold the process active just because this server is up.
                }
                catch (e) {
                }
            });
        }
    };
    ;
    ListeningPort.prototype.handleRequest = function (request, response) {
        response.end();
    };
    ListeningPort.prototype.stopListening = function () {
        if (this.server) {
            this.server.close();
        }
    };
    return ListeningPort;
}());
exports.ListeningPort = ListeningPort;
//# sourceMappingURL=listening-port.js.map