"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var base_proxy_1 = require("../base-proxy");
var version = require("../../../package.json").version;
var sl_js_infra_1 = require("sl-js-infra");
var FootprintsServiceProxy = /** @class */ (function (_super) {
    __extends(FootprintsServiceProxy, _super);
    function FootprintsServiceProxy(cfg, request, logger) {
        return _super.call(this, cfg, request, logger) || this;
    }
    FootprintsServiceProxy.prototype.submitFootprints = function (packetToSend, callback) {
        if (!packetToSend) {
            this.logger.info("Submit footprints - got null or empty packet. Skip submitting.");
            return;
        }
        var bufferToSend = new Buffer(JSON.stringify(packetToSend));
        var hitFiles = this.getHitFiles(packetToSend);
        this.logger.debug("Submitting footprints, tests: %s", JSON.stringify(packetToSend.tests));
        this.logger.debug("Submitting footprints, files: %s", hitFiles);
        var url = "/v5/agents/footprints";
        this.post(bufferToSend, url, callback);
    };
    FootprintsServiceProxy.prototype.getHitFiles = function (packetToSend) {
        if (!this.logger.debug()) {
            return;
        }
        var formatter = new sl_js_infra_1.SlJsInfra.MessageFormatter();
        if (packetToSend && packetToSend.apps && packetToSend.apps[0] && packetToSend.apps[0].files) {
            packetToSend.apps[0].files.forEach(function (file) {
                formatter.addContent(file.path);
            });
        }
        return formatter.content;
    };
    return FootprintsServiceProxy;
}(base_proxy_1.BaseProxy));
exports.FootprintsServiceProxy = FootprintsServiceProxy;
//# sourceMappingURL=footprints-service-proxy.js.map