"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Created by nadav on 12/03/2017.
 */
var fs = require('fs');
var toAbsolutePath = require('path').resolve;
var ArgumentResolver = /** @class */ (function () {
    function ArgumentResolver(userMessageHelper, argumentName) {
        this.userMessageHelper = userMessageHelper;
        this.argumentName = argumentName;
        this.userMessageHelper = userMessageHelper;
    }
    ArgumentResolver.prototype.resolve = function (argument, filePath, environmentVariableName) {
        if (argument) {
            return argument;
        }
        if (filePath) {
            argument = this.tryGetValueFromFile(filePath);
            if (argument) {
                this.userMessageHelper.println("Argument '" + this.argumentName + "' resolved from file. Value: " + argument);
                return argument;
            }
        }
        if (process.env && environmentVariableName) {
            argument = process.env[environmentVariableName];
            if (argument) {
                this.userMessageHelper.println("Argument '" + this.argumentName + "' resolved from environment variable ('" + environmentVariableName + "'). Value: " + argument);
                return argument;
            }
            var fileEnvVariable = environmentVariableName + "_FILE";
            filePath = process.env[fileEnvVariable];
            argument = this.tryGetValueFromFile(filePath);
            if (argument) {
                this.userMessageHelper.println("Argument '" + this.argumentName + "' resolved from environment variable ('" + fileEnvVariable + "'). Value: " + argument);
                return argument;
            }
        }
        this.userMessageHelper.println("Argument '" + this.argumentName + "' could not be resolved");
        return null;
    };
    ArgumentResolver.prototype.tryGetValueFromFile = function (argumentFile) {
        try {
            console.log("1" + argumentFile);
            if (argumentFile) {
                console.log("2" + argumentFile);
                if (fs.existsSync(argumentFile)) {
                    console.log("4" + argumentFile);
                    var contents = fs.readFileSync(argumentFile, 'utf8');
                    return contents;
                }
                this.userMessageHelper.printError("The provided file '" + toAbsolutePath(argumentFile) + "' does not exists.");
            }
        }
        catch (e) {
            this.userMessageHelper.printError("Failed to get content of file '" + toAbsolutePath(argumentFile) + "'. Error: ", e);
        }
        console.log("3" + argumentFile);
        return null;
    };
    return ArgumentResolver;
}());
exports.ArgumentResolver = ArgumentResolver;
//# sourceMappingURL=ArgumentResolver.js.map