"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 *  Creates json object with tests to exclude.
 *  Data receives from recommended tests api
 */
var sl_js_infra_1 = require("sl-js-infra");
var ValidationUtils = sl_js_infra_1.SlJsInfra.Utils.ValidationUtils;
var RecommendationSetStatus = sl_js_infra_1.SlJsInfra.Entities.RecommendationSetStatus;
var TestSelectionStatus = sl_js_infra_1.SlJsInfra.Entities.TestSelectionStatus;
var DEBUG_LEVEL_CODE = 20;
var TestRecommendationHandler = /** @class */ (function () {
    function TestRecommendationHandler(buildSessionId, testStage, enforceFullRun, backendProxy, eventsProcess, agentEventsController, logger) {
        this.SLEEP_BETWEEN_RETRIES = 5000;
        ValidationUtils.verifyNotNullOrEmpty(buildSessionId, 'buildSessionId');
        ValidationUtils.verifyNotNullOrEmpty(testStage, 'testStage');
        ValidationUtils.verifyNotNullOrEmpty(enforceFullRun, 'enforceFullRun');
        ValidationUtils.verifyNotNullOrEmpty(backendProxy, 'backendProxy');
        ValidationUtils.verifyNotNullOrEmpty(eventsProcess, 'eventsProcess');
        ValidationUtils.verifyNotNullOrEmpty(agentEventsController, 'agentEventsController');
        ValidationUtils.verifyNotNullOrEmpty(logger, 'logger');
        this.buildSessionId = buildSessionId;
        this.testStage = testStage;
        this.enforceFullRun = enforceFullRun;
        this.backendProxy = backendProxy;
        this.eventsProcess = eventsProcess;
        this.agentEventsController = agentEventsController;
        this.logger = logger;
    }
    TestRecommendationHandler.prototype.getExcludedTests = function () {
        return __awaiter(this, void 0, void 0, function () {
            var excludedTestsMap, message, testsRecommendationResponse, excludedTests, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        excludedTestsMap = {};
                        if (!this.shouldGetRecommendation()) {
                            return [2 /*return*/, excludedTestsMap];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.getTestRecommendation()];
                    case 2:
                        testsRecommendationResponse = _a.sent();
                        if (!this.isSelectionEnabled(testsRecommendationResponse)) {
                            return [2 /*return*/, excludedTestsMap];
                        }
                        excludedTests = testsRecommendationResponse.excludedTests;
                        this.logExcludedTests(excludedTests);
                        excludedTests.forEach(function (test) { return excludedTestsMap[test.name] = true; });
                        this.eventsProcess.testSelectionStatus = TestSelectionStatus.RECOMMENDED_TESTS;
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        message = "Error while trying to get excluded tests list, run all tests as fallback. Error: " + e_1;
                        this.logger.warn(message);
                        this.agentEventsController.submitMessage(message);
                        this.eventsProcess.testSelectionStatus = TestSelectionStatus.ERROR;
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, excludedTestsMap];
                }
            });
        });
    };
    TestRecommendationHandler.prototype.getExcludedTestsAsync = function (callback) {
        this.getExcludedTests().then(function (excludedTests) { return callback(excludedTests); });
    };
    TestRecommendationHandler.prototype.getTestRecommendation = function () {
        return __awaiter(this, void 0, void 0, function () {
            var response, retries;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        retries = 0;
                        _a.label = 1;
                    case 1:
                        if (!true) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.backendProxy.getTestsRecommendation(this.buildSessionId, this.testStage)];
                    case 2:
                        response = _a.sent();
                        retries++;
                        this.logger.debug("Test recommendation status is is " + response.recommendationSetStatus + " retry " + retries + "/12");
                        if (this.shouldBreak(response, retries))
                            return [3 /*break*/, 4];
                        return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, _this.SLEEP_BETWEEN_RETRIES); })];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/, response];
                }
            });
        });
    };
    TestRecommendationHandler.prototype.shouldBreak = function (response, retries) {
        return retries >= 12 || !this.isRecommendationsEnabledAndNotReady(response);
    };
    TestRecommendationHandler.prototype.isRecommendationsEnabledAndNotReady = function (response) {
        return response && response.testSelectionEnabled !== false && response.recommendationSetStatus == RecommendationSetStatus.NOT_READY;
    };
    TestRecommendationHandler.prototype.logExcludedTests = function (excludedTests) {
        this.logger.info(excludedTests.length + " tests will be excluded");
        if (this.logger.level() === DEBUG_LEVEL_CODE) {
            this.logger.debug("The following tests will be excluded: " + JSON.stringify(excludedTests));
        }
    };
    TestRecommendationHandler.prototype.isSelectionEnabled = function (response) {
        if (response.recommendationSetStatus === RecommendationSetStatus.NOT_READY) {
            this.agentEventsController.submitMessage("Test recommendation request timed out");
            this.eventsProcess.testSelectionStatus = TestSelectionStatus.RECOMMENDATIONS_TIMEOUT;
            return false;
        }
        if (response.testSelectionEnabled === false) {
            this.agentEventsController.submitMessage("Test recommendation disabled");
            this.eventsProcess.testSelectionStatus = TestSelectionStatus.DISABLED;
            return false;
        }
        return true;
    };
    TestRecommendationHandler.prototype.shouldGetRecommendation = function () {
        if (this.enforceFullRun) {
            this.agentEventsController.submitMessage("Test recommendation disabled by configuration");
            this.eventsProcess.testSelectionStatus = TestSelectionStatus.DISABLED_BY_CONFIGURATION;
            return false;
        }
        return true;
    };
    return TestRecommendationHandler;
}());
exports.TestRecommendationHandler = TestRecommendationHandler;
//# sourceMappingURL=test-recommendation-handler.js.map